package myTest4;

import java.util.Scanner;

// GregorianCalendar형의 배열을 정렬하는 프로그램
// 1. 자연정렬이 필요한 배열 - 요소의 대소관계를 비교하여 정렬합니다.
public class HeapSort {
	
	// 출력 space1~9 칸수 정의
	static String sp1 = " ", sp2 = "  ", sp3 = "   ";
	static String sp4 = "    ", sp5 = "     ", sp6 = "      ";
	static String sp7 = "       ", sp8 = "        ";
	static String sp9 = "        ";
	
	static void swap(int[] a, int idx1, int idx2){
		int t = a[idx1];
		a[idx1] = a[idx2];
		a[idx2] = t;
	}
	
	static void downHeap(int[] a, int left, int right){
		int temp = a[left];	// 루트
		int child;					// 큰 값을 가진 노드
		int parent;				// 부모
		
		for(parent = left; parent < (right + 1) / 2; parent = child){
			int cl = parent*2+1;		// 왼쪽 자식
			int cr = cl+1;				// 오른쪽 자식
			child = (cr <= right && a[cr] > a[cl]) ? cr : cl; 	// 큰 값을 가진 노드를 자식에 대입
			if(temp >= a[child]){
				break;
			}
			a[parent] = a[child];
		}
		a[parent] = temp;
		
		/* 트리구조 출력하는 소스 시작 */
		int i=0;
		int arrLength  =a.length;
		int k=3;
		int m = 2, n =2;
		int nfloor = 2;
		if(arrLength  > k && arrLength  > 2){
			do{
				// 3,7, 15
				m= m*n; // m=4, m= 8
				k = k+m; // k=7, k= 15
				nfloor++;	// nfloor= 3, nfloor = 4 
			}while(arrLength  > k); // myvalue1 = 10
		}
			
		// if arrLength == 4, 5, 10, 15
		while(i< nfloor-1){ // i=0; nfloor = 4
			String lbranch = "/";
			String rbranch = "\\";
			if(i==0){ // 1층
				System.out.print(sp9+sp9+sp3);
				System.out.println(a[i]);
			}else if(i==1){
				System.out.print(sp9+sp6);
				System.out.print(lbranch);
				System.out.print(sp9+sp3);
				System.out.print(rbranch);
				System.out.println();
				System.out.println(sp9+sp5+a[i]+sp9+sp5+a[i+1]);
			}else{ // 2층, 3층, 4층
				if(nfloor == 3){
					nfloor3(a, arrLength, lbranch, rbranch, true);
				}else if(nfloor == 4){
					nfloor3(a, arrLength, lbranch, rbranch, false);
					int count = arrLength - 8; // 15-7 =8 
					// 4층 막대기 그리기
					for(int num=0; num<=count; num++){
						if(num % 2 == 0){
							System.out.print(sp6);
							System.out.print(lbranch);
						}else{
							System.out.print(sp3);
							System.out.print(rbranch);
						}
					}
					System.out.println();
					
					// 4층 숫자 출력하기
					for(int num=8; num<=arrLength; num++){ // 10,9,5,8,3
						if(num % 2 == 0){
							System.out.print(sp5);
							System.out.print(a[num-1]);
						}else{
							System.out.print(sp3);
							System.out.print(a[num-1]);
						}
					}
					System.out.println();
					System.out.println();
				}
			}
			i++;
		}
		/* 트리구조 출력하는 소스 끝 */
	}
	
	private static void nfloor3(int[] a, int arrLength, String lbranch, String rbranch, boolean flag) {
		// if arrLength 4 4
		int count;
		if(arrLength <= 7){
			count = arrLength - 4;			
		}else{
			count = 3;			
			arrLength = 7;
		}
		// 3층 막대기 출력
		for(int num=0; num<=count; num++){
			if(num % 2 == 0){
				if(num==0){
					System.out.print(sp7+sp3);
				}else{
					System.out.print(sp9);
				}
				System.out.print(lbranch);
			}else{
				System.out.print(sp5);
				System.out.print(rbranch);
			}
		}
		System.out.println();
		
		// 3층 숫자 출력
		for(int num=4; num<=arrLength; num++){ // 10,9,5,8,3
			if(num % 2 == 0){
				if(num==4){
					System.out.print(sp9);
					System.out.print(a[num-1]);
				}else{
					System.out.print(sp4);
					System.out.print(a[num-1]);
				}
			}else{
				System.out.print(sp8);
				System.out.print(a[num-1]);
			}
		}
		if(flag){
			System.out.println();
		}
		System.out.println();
	}

	static void heapSort(int[] a, int n){
		for(int i=(n-1)/2; i>=0; i--){	// a[i]~a[n-1]를 힙으로 만들기
			downHeap(a, i, n-1);
		}
		for(int i=n-1; i>0; i--){
			swap(a, 0, i);		// 가장 큰 요소와 아직 정렬되지 않은 부분의 마지막 요소를 교환
			downHeap(a, 0, i-1);		// a[0] ~ a[i-1]을 힙으로 만듭니다.
		}
	}
	
	public static void main(String[] args){
		Scanner stdIn = new Scanner(System.in);
		System.out.println("힙 정렬");
		System.out.println("요솟수: ");
		int nx = stdIn.nextInt();
		int[] x = new int[nx];
		
		for(int i=0; i<nx; i++){
			System.out.print("x["+i+"]: ");
			x[i] = stdIn.nextInt();
		}
		
		heapSort(x,nx);	// 배열 x를 힙 정렬합니다.
		System.out.println("오름차순으로 정렬했습니다.");
		for(int i=0; i<nx; i++){
			System.out.println("x[" + i + "]=" + x[i]);
		}
	}
}