package myTest4;

import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

// GregorianCalendar형의 배열을 정렬하는 프로그램
// 1. 자연정렬이 필요한 배열 - 요소의 대소관계를 비교하여 정렬합니다.
public class PhyscExamSort {
	
	static class PhyscData{
		String name;			// 이름
		int height;			// 키
		double vision;		// 시력
		
		PhyscData(String name, int height, double vision){
			this.name = name;
			this.height = height;
			this.vision = vision;
		}
		
		public String toString(){
			return name + " " + height + " " + vision;
		}
	
		static final Comparator<PhyscData> HEIGHT_ORDER = new HeightOrderComparator();
		
		private static class HeightOrderComparator implements Comparator<PhyscData>{
			public int compare(PhyscData d1, PhyscData d2){
				return (d1.height > d2.height) ? 1:
					(d1.height < d2.height) ? -1 : 0;
			}
		}
	}
	
	public static void main(String[] args){
		Scanner stdIn = new Scanner(System.in);
		PhyscData[] x= {
				new PhyscData("이나령",162, 0.3),
				new PhyscData("전서현",173, 0.7),
				new PhyscData("이수민",162, 2.0),
				new PhyscData("홍준기",162, 1.5),
				new PhyscData("유지훈",162, 0.4),
				new PhyscData("이호연",162, 1.2),
				new PhyscData("김한결",169, 0.8),
		};
		
		Arrays.sort(x, PhyscData.HEIGHT_ORDER);	// 배열 x를 HEIGHT_ORDER를 사용해 정렬"
		System.out.println("신체검사 리스트");
		System.out.println("이름         키     시력");
		System.out.println("----------------------");
		for(int i=0; i<x.length; i++){
			System.out.printf("%-8s%3d%5.1f\n",x[i].name, x[i].height, x[i].vision);
		}
	}
}
